#include "hlavniokno.h"
#include "ui_hlavniokno.h"

// const int v = 8;

QString radek (int i)
{
    return QString::number (v - i);
}

QString sloupec (int j)
{
    return QString ('a' + j);
}

void HlavniOkno::setupTable (QTableWidget * t)
{
    t->setRowCount (v);
    t->setColumnCount (v);

    QStringList list;
    for (int j = 0; j < v; j++)
        list << sloupec (j);
    t->setHorizontalHeaderLabels (list);

    list.clear();
    for (int i = 0; i < v; i++)
        list << radek (i);
    t->setVerticalHeaderLabels (list);

    int h = t->rowHeight(0);
    for (int j = 0; j < v; j++)
        t->setColumnWidth (j, h);
}

HlavniOkno::HlavniOkno(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::HlavniOkno)
{
    ui->setupUi(this);

    setupTable(ui->tableWidget);
    setupTable(ui->traceWidget);
}

HlavniOkno::~HlavniOkno()
{
    delete ui;
}

void HlavniOkno::skoc (int x0, int y0, int n, int x, int y)
{
    if (x >= 0 && x < v && y >= 0 && y < v && n <= limit)
    {
        QTableWidgetItem * item = ui->tableWidget->item(y, x);
        if (item == NULL)
        {
            QString t;
            if (n == 0)
                t = "zacatek";
            else
                t = sloupec (y0) + radek (x0);

            QColor c = QColor::fromHsv ((n*30)%360, 255, 255);

            item = new QTableWidgetItem;
            item->setText (QString::number(n));
            item->setToolTip (t);
            item->setBackgroundColor(c);

            ui->tableWidget->setItem (y, x, item);

            QString s = QString::number(n) + " : " +
                    t + " -> " + sloupec (y) + radek (x);
            MyNode * node = new MyNode;
            node->setText (0, s);
            node->setTextColor (0, c);

            for (int i = 0; i < v; i++)
                for (int j = 0; j < v; j++)
                {
                    QTableWidgetItem * p = ui->tableWidget->item (i, j);
                    if (p == NULL) p = new QTableWidgetItem;
                    node->pole[i][j] = p->clone ();
                }

            if (current == NULL)
               ui->treeWidget->addTopLevelItem (node);
            else
               current->addChild (node);

            QTreeWidgetItem * save = current;
            current = node;

            skoc (x, y, n+1, x+2, y+1);
            skoc (x, y, n+1, x-2, y+1);
            skoc (x, y, n+1, x+2, y-1);
            skoc (x, y, n+1, x-2, y-1);

            skoc (x, y, n+1, x+1, y+2);
            skoc (x, y, n+1, x-1, y+2);
            skoc (x, y, n+1, x+1, y-2);
            skoc (x, y, n+1, x-1, y-2);

            current = save;
        }
    }

}

void HlavniOkno::on_actionRun_triggered()
{
    ui->tableWidget->clearContents ();

    ui->treeWidget->clear ();

    current = NULL;

    limit = ui->horizontalSlider->value();

    int x = ui->spinBoxX->value();
    int y = ui->spinBoxY->value();

    skoc (0,0,0,x,y);

}

void HlavniOkno::on_treeWidget_itemClicked(QTreeWidgetItem *item, int column)
{
    MyNode * node = dynamic_cast <MyNode*> (item);
    if (node != NULL)
    {
        for (int i = 0; i < v; i++)
            for (int j = 0; j < v; j++)
                ui->traceWidget->setItem(i, j, node->pole[i][j]->clone());
    }
}
